; *******************************************************************
; *** This software is copyright 2004 by Michael H Riley          ***
; *** You have permission to use, modify, copy, and distribute    ***
; *** this software so long as this copyright notice is retained. ***
; *** This software may not be used in commercial applications    ***
; *** without express written permission from the author.         ***
; *******************************************************************

include    bios.inc
include    kernel.inc

           org     8000h
           db      'RENAME',0
           dw      9000h
           dw      endrom+7000h
           dw      2000h
           dw      endrom-2000h
           dw      2000h
           db      0

           org     2000h
           br      start

include    date.inc

start:     ghi     ra                  ; copy argument address to rf
           phi     rf
           glo     ra
           plo     rf
loop1:     lda     rf                  ; look for first less <= space
           smi     33
           bdf     loop1
           ghi     rf                  ; make copy of 2nd filename start
           phi     rc
           glo     rf
           plo     rc
           dec     rf                  ; backup to char
           ldi     0                   ; need proper termination
           str     rf
           inc     rf                  ; now find end of 2nd filename
loop2:     lda     rf                  ; look for first less <= space
           smi     33
           bdf     loop2
           dec     rf                  ; backup to char
           ldi     0                   ; need proper termination
           str     rf
           ghi     ra                  ; get source filename
           phi     rf
           glo     ra
           plo     rf
           sep     scall               ; rename the file
           dw      o_rename
           bnf     renamed             ; jump if file was opened
           ldi     high errmsg         ; get error message
           phi     rf
           ldi     low errmsg
           plo     rf
           sep     scall               ; display it
           dw      f_msg
renamed:   sep     sret                ; return to os

errmsg:    db      'File not found',10,13,0

endrom:    equ     $

